/*
 * file :    main.cpp
 * progect : linage_soft
 *
 */



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include "avrio.hpp"


#define i7s_sa 0x80
#define i7s_sb 0x40
#define i7s_sc 0x20
#define i7s_sd 0x10
#define i7s_se 0x08
#define i7s_sf 0x04
#define i7s_sg 0x02


#define i7s_allon  0xff//(i7s_sa | i7s_sb | i7s_sc | i7s_sd | i7s_se | i7s_sf | i7s_sg) /**< \brief all segment on - 0 for lighted segment (common anode indicators) <br>   - 0   . (    ) \ingroup group_i7s */
#define i7s_alloff 0x00 //(~i7s_allon)                            /**< \brief all segments off <br>   \ingroup group_i7s */
#define i7s_0 (i7s_sa | i7s_sb | i7s_sc | i7s_sd | i7s_se | i7s_sf) /**< \brief '0' \ingroup group_i7s */
#define i7s_1 (i7s_sb | i7s_sc)                            /**< \brief '1' \ingroup group_i7s */
#define i7s_2 (i7s_sa | i7s_sb | i7s_sd | i7s_se | i7s_sg) /**< \brief '2' \ingroup group_i7s */
#define i7s_3 (i7s_sa | i7s_sb | i7s_sc | i7s_sd | i7s_sg) /**< \brief '3' \ingroup group_i7s */
#define i7s_4 (i7s_sb | i7s_sc | i7s_sf | i7s_sg)          /**< \brief '4' \ingroup group_i7s */
#define i7s_5 (i7s_sa | i7s_sc | i7s_sd | i7s_sf | i7s_sg) /**< \brief '5' \ingroup group_i7s */
#define i7s_6 (i7s_sa | i7s_sc | i7s_sd | i7s_se | i7s_sf | i7s_sg) /**< \brief '6' \ingroup group_i7s */
#define i7s_7 (i7s_sa | i7s_sb | i7s_sc)                   /**< \brief '7' \ingroup group_i7s */
#define i7s_8 (i7s_sa | i7s_sb | i7s_sc | i7s_sd | i7s_se | i7s_sf | i7s_sg) /**< \brief '8' \ingroup group_i7s */
#define i7s_9 (i7s_sa | i7s_sb | i7s_sc | i7s_sd | i7s_sf | i7s_sg) /**< \brief '9' \ingroup group_i7s */
#define i7s_A (i7s_sa | i7s_sb | i7s_sc | i7s_se | i7s_sf & i7s_sg) /**< \brief 'A' \ingroup group_i7s */
#define i7s_b (i7s_sc | i7s_sd | i7s_se | i7s_sf | i7s_sg) /**< \brief 'b' \ingroup group_i7s */
#define i7s_C (i7s_sa | i7s_sd | i7s_se | i7s_sf)          /**< \brief 'C' \ingroup group_i7s */
#define i7s_c (i7s_sd | i7s_se | i7s_sg)                   /**< \brief 'c' \ingroup group_i7s */
#define i7s_d (i7s_sb | i7s_sc | i7s_sd | i7s_se | i7s_sg) /**< \brief 'd' \ingroup group_i7s */
#define i7s_E (i7s_sa | i7s_sd | i7s_se | i7s_sf | i7s_sg) /**< \brief 'E' \ingroup group_i7s */
#define i7s_F (i7s_sa | i7s_se | i7s_sf | i7s_sg)          /**< \brief 'F' \ingroup group_i7s */
#define i7s_H (i7s_sb | i7s_sc | i7s_se | i7s_sf | i7s_sg) /**< \brief 'H' \ingroup group_i7s */
#define i7s_h (i7s_sc | i7s_se | i7s_sf | i7s_sg)          /**< \brief 'h' \ingroup group_i7s */
#define i7s_L (i7s_sd | i7s_se | i7s_sf)                   /**< \brief 'L' \ingroup group_i7s */
#define i7s_n (i7s_sc | i7s_se | i7s_sg)                   /**< \brief 'n' \ingroup group_i7s */
#define i7s_o (i7s_sc | i7s_sd | i7s_se | i7s_sg)          /**< \brief 'o' \ingroup group_i7s */
#define i7s_P (i7s_sa | i7s_sb | i7s_se | i7s_sf | i7s_sg) /**< \brief 'P' \ingroup group_i7s */
#define i7s_q (i7s_sa | i7s_sb | i7s_sc | i7s_sf | i7s_sg) /**< \brief 'q' \ingroup group_i7s */
#define i7s_r (i7s_se | i7s_sg)                            /**< \brief 'r' \ingroup group_i7s */
#define i7s_t (i7s_sd | i7s_se | i7s_sf | i7s_sg)          /**< \brief 't' \ingroup group_i7s */
#define i7s_Y (i7s_sb | i7s_sc | i7s_sd | i7s_sf | i7s_sg) /**< \brief 'Y' \ingroup group_i7s */
#define i7s_U (i7s_sb | i7s_sc | i7s_sd | i7s_se | i7s_sf) /**< \brief 'U' \ingroup group_i7s */
#define i7s_u (i7s_sc | i7s_sd | i7s_se)                   /**< \brief 'u' \ingroup group_i7s */
#define i7s_Pcyr (i7s_sa | i7s_sb | i7s_sc | i7s_se | i7s_sf) /**< \brief 'P cyrillic' \ingroup group_i7s */
#define i7s_Gcyr (i7s_sa | i7s_se | i7s_sf)                /**< \brief 'G cyrillic' \ingroup group_i7s */


#define MAX_POS 199999
#define MIN_POS -199999

#define IMP_PER_MKM 2
#define NUM_DIG 6

#ifndef sbi
	#define sbi(reg,bit)  reg |= (_BV(bit))
#endif
#ifndef cbi
	#define cbi(reg,bit)	reg &= ~(_BV(bit))
#endif

#define BYTENO(x,n) (*(((unsigned char*)&x)+n))

const unsigned char sign[] = {i7s_0,i7s_1,i7s_2,i7s_3,i7s_4,i7s_5,i7s_6,i7s_7,i7s_8,i7s_9};

using namespace AVRIO;
__port<__port_B> port_B;
__port<__port_C> port_C;
__port<__port_D> port_D;

__in<__port_D,__bit_5> zero_btn;
__in<__port_C,__bit_2> lost_pwr;

__in<__port_D,__bit_2> encoder_ap;
__in<__port_D,__bit_3> encoder_bp;

__out<__port_B,__bit_0> rclc;
__out<__port_B,__bit_1> srclr;

__out<__port_B,__bit_3> data;
__out<__port_B,__bit_5> clk;


volatile long enc_pos = 0;//  
long EEMEM ee_enc_pos = 0;

long tmp_pos;


char num[20];//     
unsigned char dig[NUM_DIG];//     

//       
register volatile unsigned char counter_1 asm("r2");
register volatile unsigned char counter_2 asm("r3");
register volatile unsigned char counter_3 asm("r4");
register volatile unsigned char counter_4 asm("r5");


register volatile unsigned char sreg_save asm("r6");



extern "C" void INT0_vect(void) __attribute__ ((signal, __INTR_ATTRS,naked));

inline void zero_counter(void)
{
	atomic block;
	counter_1 = 0x00;
	counter_2 = 0x00;
	counter_3 = 0x00;
	counter_4 = 0x00;

}

long get_counter(void)
{
	long res;
	{
		atomic block;
		BYTENO(res,0) = counter_1;
		BYTENO(res,1) = counter_2;
		BYTENO(res,2) = counter_3;
		BYTENO(res,3) = counter_4;
	}
	return res;
}

//extern "C" void INT1_vect(void) __attribute__ ((signal, __INTR_ATTRS));



int spi_putchar(char c)
{
	//while(!(SPSR & (1<<SPIF))){};

	SPDR = c;
	loop_until_bit_is_set(SPSR,SPIF);

	return 0;
}

void convert(void);//    
void print(void);//   



/*
 * MAIN   
 */
int main()
{

	//  /
	//port_B.set_DDR(0xff);
	//port_B.set_port(0x00);
	//port_C.set_DDR(0xff);
	//port_C.set_port(0x00);
	//port_D.set_DDR(0xd3);
	//port_D.set_port(0x20);

start:
	DDRB = 0xff;
	PORTB = 0x04;

	DDRC = 0x00;
	PORTC = 0xfb;

	DDRD = 0x00;
	PORTD = 0xff;



	//  
	GICR = _BV(INT0);// 
	MCUCR = _BV(ISC00);//    

	// SPI
	/*
    sbi(PORTB, 5);  // set SCK hi
    sbi(DDRB, 5);   // set SCK as output
    cbi(DDRB, 4);   // set MISO as input
    sbi(DDRB, 3);   // set MOSI as output
    sbi(DDRB, 2);   // SS must be output for Master mode to work
    */
	SPCR = _BV(SPE)|_BV(MSTR)|_BV(SPR1)|_BV(SPR0)|_BV(CPOL)|_BV(DORD);//   
	num[0]=SPSR;



	//while(lost_pwr.is_set()) _delay_ms(50);

	//    EEPROM
	eeprom_busy_wait();
	eeprom_read_block((void*)(&enc_pos),&ee_enc_pos,sizeof(long));
	eeprom_busy_wait();


	sei();//  

	srclr.set();
	//sbi(PORTB,PB1);

	for(;;)//  
	{
		_delay_ms(50);
		convert();
		print();

		if(zero_btn.is_clear())
		{
			//
			int zero_count;
			zero_count = 0;
			for(int i = 0;i<100;i++)
			{
				if(zero_btn.is_clear())
				{
					zero_count++;
				}
			}

			if (zero_count>90)
			{
				zero_counter();
			}
		}

		if(lost_pwr.is_clear())
		{
			//
			int zero_count;
			zero_count = 0;
			for(int i = 0;i<100;i++)
			{
				if(lost_pwr.is_clear())
				{
					zero_count++;
				}
			}

			if (zero_count>90)
			{
				atomic bloc;
				eeprom_busy_wait();
				eeprom_write_block((void*)(&enc_pos),&ee_enc_pos,sizeof(long));
				eeprom_busy_wait();
				goto start;
			}
		}


	}//  

	return 0;
}
/*
 * MAIN   
 */
//-----------------------------------------------------------------------------------
void INT0_vect(void)
{

	asm(	"in r6,__SREG__""\n\t"//  
			"cli""\n\t"
			"push __zero_reg__""\n\t"//    
			"push r20""\n\t"//    
			"push r21""\n\t"//    
			"push r25""\n\t"//    


			"eor __zero_reg__,__zero_reg__""\n\t"

			// 
			"in r20,%0""\n\t"// PIND
			"andi r20,0x0C""\n\t"// 
			"mov r25,r20""\n\t"

			"eor r25,r7""\n\t"//   
			"mov r7,r20""\n\t"// 

			"andi r25,0x0C""\n\t"// 
			"ldi r21,0x0C""\n\t"
			"cp r21,r25""\n\t"
			"brne  L_exit%=""\n\t"


			//filter
			//"ldi r16,0x30""\n\t"
			//"L_flt%=:""\n\t"
			//"dec r16""\n\t"
			//"brne L_flt%=""\n\t"

			// 
			//"in r20,%0""\n\t"
			//"in r21,%0""\n\t"
			"mov r21,r20""\n\t"
			"andi r20,0x04""\n\t"
			"andi r21,0x08""\n\t"
			"ror r21""\n\t"
			"cp r21,r20""\n\t"
			"breq  L_dec%=""\n\t"

			// 
			"L_inc%=:""\n\t"
			"ldi r25,0x01""\n\t"
			"add r2,r25""\n\t"
			"adc r3,__zero_reg__""\n\t"
			"adc r4,__zero_reg__""\n\t"
			"adc r5,__zero_reg__""\n\t"
			"rjmp L_exit%=""\n\t"

			//  
			"L_dec%=:""\n\t"
			"ldi r25,0x01""\n\t"
			"sub r2,r25""\n\t"
			"sbc r3,__zero_reg__""\n\t"
			"sbc r4,__zero_reg__""\n\t"
			"sbc r5,__zero_reg__""\n\t"

			"L_exit%=:""\n\t"


			"pop r25""\n\t"//    
			"pop r21""\n\t"//    
			"pop r20""\n\t"//    
			"pop __zero_reg__""\n\t"
			"out __SREG__,r6""\n\t"
			"reti""\n\t"


			: : "I" (_SFR_IO_ADDR(PIND)));

}
//-----------------------------------------------------------------------------------
/*
void INT1_vect(void)
{
	// 
	//enc_pos--;
	//test2++;
}
*/
//-----------------------------------------------------------------------------------
void convert()//    
{

	{
		//atomic block;
		//tmp_pos = enc_pos;
	}
	tmp_pos = get_counter();


	long pos_mkm = tmp_pos;
	//long pos_mkm = (tmp_pos*25)/10;

	//debug
	//pos_mkm = -188888;

	int cursor ;

	if((pos_mkm<MAX_POS)&&(pos_mkm>MIN_POS))
	//if(1)
	{
		ltoa(pos_mkm,num,10);
		if(pos_mkm>=0)
		{
			cursor = strlen(num) - 1;

			for(int iter=NUM_DIG-1;iter>0;iter--)
			{
				if(cursor<0)
				{
					dig[NUM_DIG-iter-1]=sign[0];
				}
				else
				{
					dig[NUM_DIG-iter-1]=sign[num[cursor]-0x30];
				}

				cursor--;
			}
			if(pos_mkm>100000)
			{
				dig[5]=sign[1];
			}
			else
			{
				dig[5]=i7s_alloff;
			}
		}
		if(pos_mkm<0)
		{
			ltoa(labs(pos_mkm),num,10);
			cursor = strlen(num) - 1;

			for(int iter=NUM_DIG-1;iter>0;iter--)
			{
				if(cursor<0)
				{
					dig[NUM_DIG-iter-1]=sign[0];
				}
				else
				{
					dig[NUM_DIG-iter-1]=sign[num[cursor]-0x30];
				}

				cursor--;
			}

			dig[5]=i7s_sg;

			if(pos_mkm<-100000)
			{
				dig[5]=sign[1]|i7s_sg;
			}
		}
	}
	else
	{
		//    
		dig[5] = i7s_alloff;
		dig[4] = i7s_E;
		dig[3] = i7s_r;
		dig[2] = i7s_r;
		dig[1] = i7s_o;
		dig[0] = i7s_r;

	}
}
//-----------------------------------------------------------------------------------
void print(void)//   
{

	for(int iter=0;iter<NUM_DIG;iter++)
	{
		spi_putchar(dig[iter]);
		//put_char(dig[iter]);

	}

	rclc.set();
	_delay_us(100);
	rclc.clr();
	_delay_us(100);

}


